PROGRAM  Objets_Boutons;                            { 28/05/1994 par: Lad MESSAOUDI
                                                    Integration Souris}
         USES
              Crt , Graph, Dos, Mouse;

{============================ CLASSES ======================================}

TYPE
    Point = OBJECT
                  X, Y    : Integer;     { position du point }
                  CoulP   : Byte;        { couleur du point }
                  CoulF   : Byte;        { couleur du Fond }

                  CONSTRUCTOR Init (InitX, InitY : Integer);
                  PROCEDURE SetCouleur (Couleur, CoulFond : Byte);
                  PROCEDURE Affiche; Virtual;
                  PROCEDURE Cache;   Virtual;
                  PROCEDURE SetPosition (NouvoX, NouvoY : Integer);
                  PROCEDURE GetInfo (AncX, AncY : Integer; AncCoul,AncCoulF : Byte);
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    P_Bouton = OBJECT ( Point )
                    X1, Y1, X2, Y2  : Integer;
                    EpBord          : Integer;
                    Pos_Haute       : Boolean;

                  CONSTRUCTOR Init (InitX1, InitY1, InitX2, InitY2 : Integer);
                  PROCEDURE Affiche; Virtual;
                  PROCEDURE Cache ;  Virtual;
                  PROCEDURE Inverse;
                  PROCEDURE SetPosition (NouvoX, NouvoY, NouvoX2, NouvoY2, Ep_Bordure : Integer);
                  PROCEDURE SetTexte(Xt1,Yt1,Xt2,Yt2 : Integer; Texte : String; CoulT : Byte);
                  PROCEDURE GetInfo (AncX, AncY, AncX2, AncY2  : Integer; AncCoul : Byte);
                  FUNCTION  Presse (SourisX, SourisY : Integer): Boolean;
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    P_BoutonS = OBJECT ( P_Bouton )
                       CoulB           : Byte;

                  PROCEDURE SetCouleur (Couleur, CoulFond, CoulBord : Byte);
                  PROCEDURE Affiche; Virtual;
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    P_BoutonE = OBJECT (P_BoutonS)

                  PROCEDURE Affiche; Virtual;
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    G_Bouton = OBJECT ( P_Bouton )

                  PROCEDURE Affiche; Virtual;
                  PROCEDURE Cache; Virtual;
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    G_BoutonS = OBJECT ( G_Bouton )
                         CoulB           : Byte;

                  PROCEDURE SetCouleur (Couleur, CoulFond, CoulBord : Byte);
                  PROCEDURE Affiche; Virtual;
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    G_BoutonE = OBJECT ( G_BoutonS )

                  PROCEDURE Affiche; Virtual;
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

{===========================================================================}
                        {*****  Objet Point *****}
{===========================================================================}
CONSTRUCTOR Point.Init (InitX, InitY : Integer);

Begin
     X := InitX;
     Y := InitY;

           If X < 1    Then  X := 1;
           If X > 639  Then  X := 639;
           If Y < 1    Then  Y := 1;
           If Y > 479  Then  Y := 479;
End;

{===========================================================================}
PROCEDURE Point.SetCouleur (Couleur, CoulFond : Byte);

Begin
     CoulP  := Couleur;
     CoulF  := CoulFond;
End;

{===========================================================================}
PROCEDURE Point.Affiche;

Begin
     SetBkColor(CoulF);
     SetColor(CoulP);
     PutPixel (X,Y,GetColor);
End;

{===========================================================================}
PROCEDURE Point.Cache;

Begin
     PutPixel (X,Y,GetBkColor);
End;

{===========================================================================}
PROCEDURE Point.SetPosition (NouvoX, NouvoY : Integer);

Begin
           X := NouvoX;
           Y := NouvoY;

           If X < 1    Then  X := 1;
           If X > 600  Then  X := 600;
           If Y < 1    Then  Y := 1;
           If Y > 400  Then  Y := 400;
End;

{===========================================================================}
PROCEDURE Point.GetInfo (AncX, AncY : Integer; AncCoul, AncCoulF : Byte);

Begin
     AncX     := X ;
     AncY     := Y;
     AncCoul  := CoulP;
     AncCoulF := CoulF;
End;

{===========================================================================}
                      {*****  Objet Petit_Bouton *****}
{**************************************************************************}
CONSTRUCTOR P_Bouton.Init (InitX1, InitY1, InitX2, InitY2 : Integer);

Begin
     X1 := InitX1;
     Y1 := InitY1;
     X2 := InitX2;
     Y2 := InitY2;
End;

{**************************************************************************}
PROCEDURE P_Bouton.Affiche;

Begin
      SetBkColor(CoulF);
      SetFillStyle(1,CoulP);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

End;

{***************************************************************************}
PROCEDURE P_Bouton.Cache;

Begin

      SetFillStyle(1,CoulF);      { couleur du bouton }
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(CoulF);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(CoulF);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

End;

{***************************************************************************}
PROCEDURE P_Bouton.SetPosition (NouvoX,NouvoY,NouvoX2,NouvoY2,Ep_Bordure  : Integer);

Begin
           X1      :=  NouvoX;
           Y1      :=  NouvoY;
           X2      :=  NouvoX2;
           Y2      :=  NouvoY2;
           EpBord  :=  Ep_Bordure;
End;

{***************************************************************************}
PROCEDURE P_Bouton.SetTexte(Xt1,Yt1,Xt2,Yt2 : Integer; Texte : String; CoulT : Byte);

Var  Long_Texte : Byte;

BEGIN
     SetColor(CoulT);
     Long_Texte := Length(Texte)*8 Div 2 ;
     OutTextXY((Xt1+Xt2) Div 2 - Long_Texte,
                                     (Yt2-Yt1) Div 2 + Yt1 - 3 , Texte);

END;

{===========================================================================}
PROCEDURE P_Bouton.GetInfo (AncX, AncY, AncX2, AncY2 : Integer; AncCoul : Byte);

Begin
     AncX     :=    X1 ;
     AncY     :=    Y1;
     AncX2    :=    X2 ;
     AncY2    :=    Y2;
     AncCoul  :=    CoulP;
End;
{===========================================================================}

{***************************************************************************}
                  {*****  Objet Petit_Bouton_Sortant *****}

{**************************************************************************}
PROCEDURE P_BoutonS.SetCouleur (Couleur, CoulFond, CoulBord : Byte);

Begin
     CoulP  := Couleur;
     CoulF  := CoulFond;
     CoulB  := CoulBord;
End;

{**************************************************************************}
PROCEDURE P_BoutonS.Affiche;

Var
   Xs1, Ys1, Xs2, Ys2   : Integer;

Begin
      Xs1 := X1 + EpBord ;   Ys1 := Y1 + EpBord;
      Xs2 := X2 - EpBord ;   Ys2 := Y2 - EpBord;

      SetBkColor(CoulF);
      SetFillStyle(1,CoulB);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

      SetFillStyle(1,CoulP);
      Bar(Xs1,Ys1,Xs2,Ys2);
      SetLineStyle(0,1,1);
      SetColor(8);
      Rectangle(Xs1,Ys1,Xs2,Ys2);
      SetColor(15);
      Line(Xs1,Ys1,Xs2,Ys1);
      Line(Xs1,Ys1,Xs1,Ys2-1);

      Pos_Haute := True;
End;

{**************************************************************************}
PROCEDURE P_Bouton.Inverse;

Begin
     Pos_Haute := Not Pos_Haute;
     Affiche;
End;

{**************************************************************************}
FUNCTION P_Bouton.Presse(SourisX, SourisY : Integer): Boolean;

Var      Resultat : Boolean;

Begin
     Resultat := False;
     If (SourisX < X1) And (SourisX > X2) And
        (SourisY < Y1) And (SourisY > Y2) Then
        Resultat := true;
     If Resultat Then Inverse;
     Presse := Resultat;

End;
{***************************************************************************}
                 {*****  Objet Petit_Bouton_Entrant *****}
{**************************************************************************}
PROCEDURE P_BoutonE.Affiche;

Var
   Xs1, Ys1, Xs2, Ys2   : Integer;

Begin
      Xs1 := X1 + EpBord ;   Ys1 := Y1 + EpBord;
      Xs2 := X2 - EpBord ;   Ys2 := Y2 - EpBord;

      SetBkColor(CoulF);
      SetFillStyle(1,CoulB);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

      SetFillStyle(1,CoulP);
      Bar(Xs1,Ys1,Xs2,Ys2);
      SetLineStyle(0,1,1);
      SetColor(15);
      Rectangle(Xs1,Ys1,Xs2,Ys2);
      SetColor(8);
      Line(Xs1,Ys1,Xs2,Ys1);
      Line(Xs1,Ys1,Xs1,Ys2-1);

      Pos_Haute := False;
End;

{***************************************************************************}
                 {*****  Objet Grand_Bouton *****}
{***************************************************************************}
PROCEDURE G_Bouton.Affiche;

Begin
      SetBkColor(CoulF);
      SetFillStyle(1,CoulP);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,3);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      SetLineStyle(0,1,1);
      Line(X1,Y1-1,X2,Y1-1);
      Line(X1,Y1,X2-1,Y1);
      Line(X1,Y1+1,X2-2,Y1+1);
      Line(X1-1,Y1,X1-1,Y2);
      Line(X1,Y1,X1,Y2-1);
      Line(X1+1,Y1,X1+1,Y2-2);

End;

{***************************************************************************}
PROCEDURE G_Bouton.Cache;

Begin
      SetBkColor(CoulF);
      SetFillStyle(1,CoulF);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,3);
      SetColor(CoulF);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(CoulF);
      SetLineStyle(0,1,1);
      Line(X1,Y1-1,X2,Y1-1);
      Line(X1,Y1,X2-1,Y1);
      Line(X1,Y1+1,X2-2,Y1+1);
      Line(X1-1,Y1,X1-1,Y2);
      Line(X1,Y1,X1,Y2-1);
      Line(X1+1,Y1,X1+1,Y2-2);
End;

{***************************************************************************}
                 {*****  Objet Grand_Bouton_Sortant *****}
{**************************************************************************}
PROCEDURE G_BoutonS.SetCouleur (Couleur, CoulFond, CoulBord : Byte);

Begin
     CoulP  := Couleur;
     CoulF  := CoulFond;
     CoulB  := CoulBord;
End;

{**************************************************************************}
PROCEDURE G_BoutonS.Affiche;

Var
   Xs1, Ys1, Xs2, Ys2   : Integer;

Begin
      Xs1 := X1 + EpBord ;   Ys1 := Y1 + EpBord;
      Xs2 := X2 - EpBord ;   Ys2 := Y2 - EpBord;

      SetBkColor(CoulF);
      SetFillStyle(1,CoulB);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,3);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      SetLineStyle(0,1,1);
      Line(X1,Y1-1,X2,Y1-1);
      Line(X1,Y1,X2-1,Y1);
      Line(X1,Y1+1,X2-2,Y1+1);
      Line(X1-1,Y1,X1-1,Y2);
      Line(X1,Y1,X1,Y2-1);
      Line(X1+1,Y1,X1+1,Y2-2);

      SetFillStyle(1,CoulP);
      Bar(Xs1,Ys1,Xs2,Ys2);
      SetLineStyle(0,1,3);
      SetColor(8);
      Rectangle(Xs1,Ys1,Xs2,Ys2);
      SetColor(15);
      SetLineStyle(0,1,1);
      Line(Xs1,Ys1-1,Xs2,Ys1-1);
      Line(Xs1,Ys1,Xs2-1,Ys1);
      Line(Xs1,Ys1+1,Xs2-2,Ys1+1);

      Line(Xs1-1,Ys1,Xs1-1,Ys2);
      Line(Xs1,Ys1,Xs1,Ys2-1);
      Line(Xs1+1,Ys1,Xs1+1,Ys2-2);

End;

{***************************************************************************}
                 {*****  Objet Grand_Bouton_Entrant *****}
{***************************************************************************}
PROCEDURE G_BoutonE.Affiche;

Var
   Xs1, Ys1, Xs2, Ys2   : Integer;

Begin
      Xs1 := X1 + EpBord ;   Ys1 := Y1 + EpBord;
      Xs2 := X2 - EpBord ;   Ys2 := Y2 - EpBord;

      SetBkColor(CoulF);
      SetFillStyle(1,CoulB);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,3);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      SetLineStyle(0,1,1);
      Line(X1,Y1-1,X2,Y1-1);
      Line(X1,Y1,X2-1,Y1);
      Line(X1,Y1+1,X2-2,Y1+1);
      Line(X1-1,Y1,X1-1,Y2);
      Line(X1,Y1,X1,Y2-1);
      Line(X1+1,Y1,X1+1,Y2-2);

      SetFillStyle(1,CoulP);
      Bar(Xs1,Ys1,Xs2,Ys2);
      SetLineStyle(0,1,3);
      SetColor(15);
      Rectangle(Xs1,Ys1,Xs2,Ys2);
      SetColor(8);
      SetLineStyle(0,1,1);
      Line(Xs1,Ys1-1,Xs2,Ys1-1);
      Line(Xs1,Ys1,Xs2-1,Ys1);
      Line(Xs1,Ys1+1,Xs2-2,Ys1+1);
      Line(Xs1-1,Ys1,Xs1-1,Ys2);
      Line(Xs1,Ys1,Xs1,Ys2-1);
      Line(Xs1+1,Ys1,Xs1+1,Ys2-2);

End;
{***************************************************************************}

Var
   PBouton                : P_Bouton;
   PBoutonS               : P_BoutonS;
   PBoutonE               : P_BoutonE;

   GBouton                : G_Bouton;
   GBoutonS               : G_BoutonS;
   GBoutonE               : G_BoutonE;

   Grmode, GrPilote, CodeErreur       : Integer;
   X, Y, X1, Y1, X2, Y2, i            : Integer;
   CoulP                              : Byte;


BEGIN
     GrPilote := Detect;
     InitGraph(GrPilote,GrMode,'D:\BP\BGI');
     CodeErreur := GraphResult;
     If CodeErreur <> 0 Then Begin
                                  Write('Erreur de type Graphique ');
                                  ReadLn;
                             End
     Else
    Begin
         ClearDevice;
{-------------------------- PBouton ----------------------------------------
 With PBouton Do
   Begin
      Init(0,0,0,0);
      SetCouleur (1,3);
      SetPosition(10,100,500,160,5);
      Affiche;
      SetTexte(10,100,500,160,'Programmation en TurboPascal',14);
      Delay(4000);
      Cache;
      Delay(3000);
   End;

-------------------------- PBouton S ou E----------------------------------}
 With PBoutonS Do
   Begin
      Init(0,0,0,0);
      SetCouleur (1,3,1);
      SetPosition(10,10,500,360,5);
      Affiche;
      SetTexte(10,100,500,160,'Programmation en TurboPascal',14);
      Delay(4000);
   End;

  With PBoutonE Do
   Begin
        Init(0,0,0,0);
        SetCouleur (1,3,1);
        SetPosition(10,10,500,360,5);
        Affiche;
        SetTexte(10,100,500,160,'Programmation en TurboPascal',14);
        Delay(4000);

        Cache;
        SetCouleur (6,3,6);
        SetPosition(150,250,500,300,5);
        Affiche;
        SetTexte(150,250,500,300,'Programmation Oriente Objet',14);
        Delay(4000);
   End;

  With PBoutonS Do
       Begin
            SetCouleur (6,3,6);
            SetPosition(150,250,500,300,5);
            Affiche;
            SetTexte(150,250,500,300,'Programmation Oriente Objet',14);
            Delay(4000);

            Cache;
       End;
{-------------------------- GBouton ----------------------------------------}
 With GBouton Do
   Begin
      Init(0,0,0,0);
      SetCouleur (1,3);
      SetPosition(10,100,500,160,15);
      Affiche;
      SetTexte(10,100,500,160,'Programmation en TurboPascal',14);
      Delay(4000);
      Cache;
      Delay(3000);
   End;
{-------------------------- GBouton E ou S----------------------------------}
 With GBoutonS Do
   Begin
      Init(0,0,0,0);
      SetCouleur (1,3,1);
      SetPosition(10,10,500,360,35);
      Affiche;
      SetTexte(10,100,500,160,'Programmation en TurboPascal',14);
      Delay(4000);
   End;

  With GBoutonE Do
   Begin
        Init(0,0,0,0);
        SetCouleur (1,3,1);
        SetPosition(10,10,500,360,35);
        Affiche;
        SetTexte(10,100,500,160,'Programmation en TurboPascal',14);
        Delay(4000);

        Cache;

        SetCouleur (6,3,6);
        SetPosition(150,250,500,300,7);
        Affiche;
        SetTexte(150,250,500,300,'Programmation Oriente Objet',14);
        Delay(4000);
   End;

  With GBoutonS Do
       Begin
            SetCouleur (6,3,6);
            SetPosition(150,250,500,300,7);
            Affiche;
            SetTexte(150,250,500,300,'Programmation Oriente Objet',14);
            Delay(4000);

            Cache;
       End;


     ReadLn;

    End;
    CloseGraph;
END.

