UNIT  Imane;                                 { 17/07/94 }

INTERFACE

USES
     Crt , Graph, Dos, Mouse;
{============================ CLASSES ======================================}

TYPE
    Point = OBJECT
                  X, Y    : Integer;     { position du point }
                  CoulP   : Byte;        { couleur du point }
                  CoulF   : Byte;        { couleur du fond }

                  CONSTRUCTOR Init (InitX, InitY : Integer);
                  PROCEDURE SetCouleur (Couleur, CoulFond : Byte);
                  PROCEDURE Affiche; Virtual;
                  PROCEDURE Cache;   Virtual;
                  PROCEDURE SetPosition (NouvoX, NouvoY : Integer);
                  PROCEDURE GetInfo (AncX, AncY : Integer; AncCoulP,AncCoulF : Byte);
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

    BoutonType = (NBouton, PBouton, GBouton);

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    Bouton = OBJECT (POINT)
                  X1, Y1, X2, Y2    : Integer;
                  Etat, Existe      : Boolean;
                  CoulB             : Byte;
                  EpBord            : Integer;
                  Style             : BoutonType;

                  CONSTRUCTOR INIT (InitX1, InitY1, InitX2, InitY2 : Integer);
                  PROCEDURE SetPosition (NouvoX1, NouvoY1, NouvoX2, NouvoY2,
                                         Ep_Bordure : Integer);
                  PROCEDURE SetCouleur (CoulBout, CoulFond, CoulBord : Byte);
                  PROCEDURE Affiche;  Virtual;
                  PROCEDURE Cache;    Virtual;
                  PROCEDURE Inverser; Virtual;
                  PROCEDURE SetEtat (EtatBout : Boolean);
                  PROCEDURE SetType (QuelType : BoutonType);
                  FUNCTION  GetEtat : Boolean;
                  FUNCTION  GetType : BoutonType;
                  FUNCTION  BoutonHit (MouseX, MouseY : Integer) : Boolean;
                  PROCEDURE SetTexte (Xt1, Yt1, Xt2, Yt2 : Integer;
                                     Texte : String; CoulT : Byte);
                  PROCEDURE GetInfo (AncX1, AncY1, AncX2, AncY2 : Integer;
                                    AncCoulF, AncCoulB, AncCoulT : Byte);
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
IMPLEMENTATION

{===========================================================================}
                        {*****  Objet Point *****}
{===========================================================================}
CONSTRUCTOR Point.Init;

Begin
     X := InitX;
     Y := InitY;

           If X < 1    Then  X := 1;
           If X > 639  Then  X := 639;
           If Y < 1    Then  Y := 1;
           If Y > 479  Then  Y := 479;
End;

{===========================================================================}
PROCEDURE Point.SetCouleur;

Begin
     CoulP  := Couleur;
     CoulF  := CoulFond;

End;

{===========================================================================}
PROCEDURE Point.Affiche;

Begin
     SetBkColor (CoulF);
     SetColor (CoulP);
     PutPixel (X,Y,GetColor);
End;

{===========================================================================}
PROCEDURE Point.Cache;

Begin
     PutPixel (X,Y,GetBkColor);
End;

{===========================================================================}
PROCEDURE Point.SetPosition;

Begin
           X := NouvoX;
           Y := NouvoY;

           If X < 1    Then  X := 1;
           If X > 639  Then  X := 639;
           If Y < 1    Then  Y := 1;
           If Y > 479  Then  Y := 479;
End;

{===========================================================================}
PROCEDURE Point.GetInfo;

Begin
     AncX      := X ;
     AncY      := Y;
     AncCoulP  := CoulP;
End;

{===========================================================================}
                      {*****  Objet Bouton *****}
{**************************************************************************}
CONSTRUCTOR Bouton.Init;

Begin
     X1 := InitX1;
     Y1 := InitY1;
     X2 := InitX2;
     Y2 := InitY2;
     Existe := False;
End;

{**************************************************************************}
PROCEDURE Bouton.Affiche;

Var   Xs1, Ys1, Xs2, Ys2   : Integer;

Begin
     Xs1 := X1 + EpBord ;   Ys1 := Y1 + EpBord;
     Xs2 := X2 - EpBord ;   Ys2 := Y2 - EpBord;

      Case Style Of

      PBouton : If Etat Then
                Begin
                     SetBkColor(CoulF);
                     SetFillStyle(1,CoulB);
                     Bar(X1,Y1,X2,Y2);
                     SetLineStyle(0,1,1);
                     SetColor(8);
                     Rectangle(X1,Y1,X2,Y2);        { P_Bouton Sortant }
                     SetColor(15);
                     Line(X1,Y1,X2,Y1);
                     Line(X1,Y1,X1,Y2-1);

                     SetFillStyle(1,CoulP);
                     Bar(Xs1,Ys1,Xs2,Ys2);
                     SetLineStyle(0,1,1);
                     SetColor(8);
                     Rectangle(Xs1,Ys1,Xs2,Ys2);
                     SetColor(15);
                     Line(Xs1,Ys1,Xs2,Ys1);
                     Line(Xs1,Ys1,Xs1,Ys2-1);
                End
                    Else
                    Begin
                        SetBkColor(CoulF);
                        SetFillStyle(1,CoulB);
                        Bar(X1,Y1,X2,Y2);
                        SetLineStyle(0,1,1);
                        SetColor(8);                 { P_Bouton Entrant }
                        Rectangle(X1,Y1,X2,Y2);
                        SetColor(15);
                        Line(X1,Y1,X2,Y1);
                        Line(X1,Y1,X1,Y2-1);

                        SetFillStyle(1,CoulP);
                        Bar(Xs1,Ys1,Xs2,Ys2);
                        SetLineStyle(0,1,1);
                        SetColor(15);
                        Rectangle(Xs1,Ys1,Xs2,Ys2);
                        SetColor(8);
                        Line(Xs1,Ys1,Xs2,Ys1);
                        Line(Xs1,Ys1,Xs1,Ys2-1);
                   End;

      GBouton : If Etat Then
                Begin
                     SetBkColor(CoulF);
                     SetFillStyle(1,CoulB);
                     Bar(X1,Y1,X2,Y2);
                     SetLineStyle(0,1,3);
                     SetColor(8);
                     Rectangle(X1,Y1,X2,Y2);
                     SetColor(15);
                     SetLineStyle(0,1,1);
                     Line(X1,Y1-1,X2,Y1-1);
                     Line(X1,Y1,X2-1,Y1);
                     Line(X1,Y1+1,X2-2,Y1+1);
                     Line(X1-1,Y1,X1-1,Y2);
                     Line(X1,Y1,X1,Y2-1);
                     Line(X1+1,Y1,X1+1,Y2-2);
                                                     { G_Bouton Sortant }
                     SetFillStyle(1,CoulP);
                     Bar(Xs1,Ys1,Xs2,Ys2);
                     SetLineStyle(0,1,3);
                     SetColor(8);
                     Rectangle(Xs1,Ys1,Xs2,Ys2);
                     SetColor(15);
                     SetLineStyle(0,1,1);
                     Line(Xs1,Ys1-1,Xs2,Ys1-1);
                     Line(Xs1,Ys1,Xs2-1,Ys1);
                     Line(Xs1,Ys1+1,Xs2-2,Ys1+1);

                     Line(Xs1-1,Ys1,Xs1-1,Ys2);
                     Line(Xs1,Ys1,Xs1,Ys2-1);
                     Line(Xs1+1,Ys1,Xs1+1,Ys2-2);
                End
                Else
                Begin
                     SetBkColor(CoulF);
                     SetFillStyle(1,CoulB);
                     Bar(X1,Y1,X2,Y2);
                     SetLineStyle(0,1,3);
                     SetColor(8);
                     Rectangle(X1,Y1,X2,Y2);
                     SetColor(15);
                     SetLineStyle(0,1,1);
                     Line(X1,Y1-1,X2,Y1-1);
                     Line(X1,Y1,X2-1,Y1);
                     Line(X1,Y1+1,X2-2,Y1+1);
                     Line(X1-1,Y1,X1-1,Y2);
                     Line(X1,Y1,X1,Y2-1);
                     Line(X1+1,Y1,X1+1,Y2-2);
                                                { G_Bouton Entrant }
                     SetFillStyle(1,CoulP);
                     Bar(Xs1,Ys1,Xs2,Ys2);
                     SetLineStyle(0,1,3);
                     SetColor(15);
                     Rectangle(Xs1,Ys1,Xs2,Ys2);
                     SetColor(8);
                     SetLineStyle(0,1,1);
                     Line(Xs1,Ys1-1,Xs2,Ys1-1);
                     Line(Xs1,Ys1,Xs2-1,Ys1);
                     Line(Xs1,Ys1+1,Xs2-2,Ys1+1);
                     Line(Xs1-1,Ys1,Xs1-1,Ys2);
                     Line(Xs1,Ys1,Xs1,Ys2-1);
                     Line(Xs1+1,Ys1,Xs1+1,Ys2-2);
                End;
      End;
      Existe := True;
End;

{***************************************************************************}
PROCEDURE Bouton.Cache;

Begin
      If Existe Then
      Begin
      Case Style Of

      PBouton : Begin
                     SetFillStyle(1,CoulF);      { couleur du bouton }
                     Bar(X1,Y1,X2,Y2);
                     SetLineStyle(0,1,1);
                     SetColor(CoulF);
                     Rectangle(X1,Y1,X2,Y2);
                     SetColor(CoulF);
                     Line(X1,Y1,X2,Y1);
                     Line(X1,Y1,X1,Y2-1);
                End;

      GBouton : Begin
                     SetBkColor(CoulF);
                     SetFillStyle(1,CoulF);
                     Bar(X1,Y1,X2,Y2);
                     SetLineStyle(0,1,3);
                     SetColor(CoulF);
                     Rectangle(X1,Y1,X2,Y2);
                     SetColor(CoulF);
                     SetLineStyle(0,1,1);
                     Line(X1,Y1-1,X2,Y1-1);
                     Line(X1,Y1,X2-1,Y1);
                     Line(X1,Y1+1,X2-2,Y1+1);
                     Line(X1-1,Y1,X1-1,Y2);
                     Line(X1,Y1,X1,Y2-1);
                     Line(X1+1,Y1,X1+1,Y2-2);
                End;
      End;
      End;
      Existe := False;
End;

{***************************************************************************}
PROCEDURE Bouton.SetPosition;

Begin
           X1      :=  NouvoX1;
           Y1      :=  NouvoY1;
           X2      :=  NouvoX2;
           Y2      :=  NouvoY2;
           EpBord  :=  Ep_Bordure
End;

{***************************************************************************}
PROCEDURE Bouton.SetTexte;

Var  Long_Texte : Byte;

BEGIN
     SetColor(CoulT);
     Long_Texte := Length(Texte)*8 Div 2 ;
     OutTextXY((Xt1+Xt2) Div 2 - Long_Texte,
                                     (Yt2-Yt1) Div 2 + Yt1 - 3 , Texte);

END;

{***************************************************************************}
PROCEDURE Bouton.GetInfo;

Begin
     AncX1     :=    X1;
     AncY1     :=    Y1;
     AncX2     :=    X2;
     AncY2     :=    Y2;
     AncCoulF  :=    CoulF;
     AncCoulB  :=    CoulB;
     AncCoulT  :=    CoulP;
End;

{**************************************************************************}
PROCEDURE Bouton.SetCouleur;

Begin
     CoulP  := CoulBout;
     CoulF  := CoulFond;
     CoulB  := CoulBord;
End;

{***************************************************************************}
PROCEDURE Bouton.Inverser;

Begin
     Etat := Not Etat;
     Affiche;
End;

{***************************************************************************}
PROCEDURE Bouton.SetEtat;

Begin
     If (Etat <> EtatBout) Then Inverser;
End;

{***************************************************************************}
PROCEDURE Bouton.SetType;

Begin
     Style := QuelType;
End;

{***************************************************************************}
FUNCTION Bouton.GetEtat;

Begin
     GetEtat := Etat;
End;

{***************************************************************************}
FUNCTION Bouton.GetType;

Begin
     GetType := STyle;
End;

{***************************************************************************}
FUNCTION Bouton.BoutonHit;

Var      Resultat : Boolean;

Begin
     If Existe Then
     Begin
          Resultat := False;
          If (MouseX >= X1) And (MouseX <= X2) And
             (MouseY >= Y1) And (MouseY <= Y2) Then
             Resultat := True;
          If Resultat Then Inverser;
          BoutonHit := Resultat;
     End;
End;

{***************************************************************************}
END.
