PROGRAM L_Bouton;                            { 18/03/94 }

USES
    Crt , Graph;
{============================ CLASSES ======================================}

TYPE
    Point = OBJECT
                  X, Y    : Integer;     { position du point }
                  CoulP   : Byte;        { couleur du point }
                  CoulF   : Byte;        { couleur du Fond }

                  PROCEDURE Init (InitX, InitY : Integer);
                  PROCEDURE SetCouleur (Couleur, CoulFond : Byte);
                  PROCEDURE Affiche;
                  PROCEDURE Cache;
                  PROCEDURE SetPosition (NouvoX, NouvoY : Integer);
                  PROCEDURE GetInfo (AncX, AncY : Integer; AncCoul,AncCoulF : Byte);
            End;

    P_Bouton = OBJECT ( Point )
                    X1, Y1, X2, Y2  : Integer;

                  PROCEDURE Init (InitX1, InitY1, InitX2, InitY2 : Integer);
                  PROCEDURE Affiche_Entrant ;
                  PROCEDURE Affiche_Sortant ;
                  PROCEDURE Cache ;
                  PROCEDURE S_SetPosition (NouvoX, NouvoY, NouvoX2, NouvoY2 : Integer);
                  PROCEDURE E_SetPosition (NouvoX, NouvoY, NouvoX2, NouvoY2 : Integer);
                  PROCEDURE GetInfo (AncX, AncY, AncX2, AncY2  : Integer; AncCoul : Byte);
            End;

                        {*****  Objet Point *****}
{===========================================================================}
PROCEDURE Point.Init (InitX, InitY : Integer);

BEGIN
     X := InitX;
     Y := InitY;

           If X < 1    Then  X := 1;
           If X > 600  Then  X := 600;
           If Y < 1    Then  Y := 1;
           If Y > 400  Then  Y := 400;
END;

{===========================================================================}
PROCEDURE Point.SetCouleur (Couleur, CoulFond : Byte);

Begin
     CoulP  := Couleur;
     CoulF  := CoulFond;
End;

{===========================================================================}
PROCEDURE Point.Affiche;

Begin
     SetColor(CoulP);
     PutPixel (X,Y,GetColor);
End;

{===========================================================================}
PROCEDURE Point.Cache;
Begin
     PutPixel (X,Y,GetBkColor);
End;

{===========================================================================}
PROCEDURE Point.SetPosition (NouvoX, NouvoY : Integer);

Begin
     Cache;
           X := NouvoX;
           Y := NouvoY;

           If X < 1    Then  X := 1;
           If X > 600  Then  X := 600;
           If Y < 1    Then  Y := 1;
           If Y > 400  Then  Y := 400;
     Affiche;
End;

{===========================================================================}
PROCEDURE Point.GetInfo (AncX, AncY : Integer; AncCoul, AncCoulF : Byte);

BEGIN
     AncX     := X ;
     AncY     := Y;
     AncCoul  := CoulP;
     AncCoulF := CoulF;
END;

{===========================================================================}
                      {*****  Objet Petit_Bouton *****}
{**************************************************************************}
PROCEDURE P_Bouton.Init (InitX1, InitY1, InitX2, InitY2 : Integer);

BEGIN
     X1 := InitX1;
     Y1 := InitY1;
     X2 := InitX2;
     Y2 := InitY2;

END;

{**************************************************************************}
PROCEDURE P_Bouton.Affiche_Sortant;

BEGIN
      SetBkColor(CoulF);
      SetFillStyle(1,CoulP);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(0);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

END;

{***************************************************************************}
PROCEDURE P_Bouton.Affiche_Entrant;

BEGIN
      SetBkColor(CoulF);
      SetFillStyle(1,CoulP);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(15);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(0);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2+1);

END;

{***************************************************************************}
PROCEDURE P_Bouton.Cache;

BEGIN
(*     GetInfo (AncX, AncY, AncX2, AncY2, AncCoul);  *)

      SetFillStyle(1,CoulF);      { couleur du bouton }
      Bar(X,Y,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(CoulF);
      Rectangle(X,Y,X2,Y2);
      SetColor(CoulF);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

END;

{***************************************************************************}
PROCEDURE P_Bouton.S_SetPosition (NouvoX,NouvoY,NouvoX2,NouvoY2 : Integer);

BEGIN
     Cache;
           X1  :=  NouvoX;
           Y2  :=  NouvoY;
           X2  :=  NouvoX2;
           Y2  :=  NouvoY2;

     Affiche_Sortant;

End;

{***************************************************************************}
PROCEDURE P_Bouton.E_SetPosition (NouvoX,NouvoY,NouvoX2,NouvoY2 : Integer);

BEGIN
     Cache;
           X1  :=  NouvoX;
           Y1  :=  NouvoY;
           X2  :=  NouvoX2;
           Y2  :=  NouvoY2;

     Affiche_Entrant;

End;

{===========================================================================}
PROCEDURE P_Bouton.GetInfo (AncX, AncY, AncX2, AncY2 : Integer; AncCoul : Byte);

BEGIN
     AncX     := X1 ;
     AncY     := Y1;
     AncX2    := X2 ;
     AncY2    := Y2;
     AncCoul  := CoulP;
END;

{===========================================================================}

{***************************************************************************}
                      {*****  Objet Grand_Bouton *****}

{***************************************************************************}
{***************************************************************************}
{**************************  Programme Principal ***************************}
VAR
   PBouton                            : P_Bouton;
   Grmode, GrPilote, CodeErreur       : Integer;
   X, Y, X1, Y1, X2, Y2               : Integer;
   CoulP                              : Byte;

BEGIN
     GrPilote := Detect;
     InitGraph(GrPilote,GrMode,'C:\TurboPas\Graph');
     CodeErreur := GraphResult;
     If CodeErreur <> 0 Then Begin
                                  Write('Erreur de type Graphique ');
                                  ReadLn;
                             End
     Else

     SetBkColor(0);

 With PBouton Do
         Begin
              Init(0,0,0,0);
              SetCouleur (1,3);
              S_SetPosition (95,95,505,155);
              ReadLn;
              S_SetPosition (100,100,500,150);
              ReadLn;
              Cache;
              ReadLn
         End;

{     PBouton.Init(0,0,0,0);        }
     PBouton.SetCouleur (6,3);
     PBouton.S_SetPosition(95,95,505,155);
     ReadLn;
     PBouton.S_SetPosition(100,100,500,150);
     ReadLn;
     PBouton.Cache;
     ReadLn;

END.