PROGRAM Laid_Boule;

USES
  Graph, Crt;

TYPE
    Emplacement = OBJECT
                         X, Y : Integer;
                         PROCEDURE Init (InitX, InitY : Integer);
                         FUNCTION AkiX : Integer;
                         FUNCTION AkiY : Integer;
                  End;

    Boule = OBJECT (Emplacement)
                  Visible : Boolean;
                  RayBoule, CoulBoule, CoulCercle : Integer;
                  PROCEDURE Init (InitX, InitY, InitRayB, InitCoulB, InitCoulC : Integer);
                  PROCEDURE Affiche;
                  PROCEDURE Cache;
                  PROCEDURE SetPosition (NouvoX, NouvoY : Integer);
                  FUNCTION EstVisible : Boolean;
            End;


                        {*****  Objet Emplacement *****}
{===========================================================================}
PROCEDURE Emplacement.Init (InitX, InitY : Integer);

Begin
     X := InitX;
     Y := InitY;
End;

{===========================================================================}
FUNCTION Emplacement.AkiX : Integer;

Begin
     AkiX := X;
End;

{===========================================================================}
FUNCTION Emplacement.AkiY : Integer;
Begin
     AkiY := Y;
End;

                      {*****  Objet Boule *****}
{===========================================================================}
PROCEDURE Boule.Init (InitX, InitY, InitRayB, InitCoulB, InitCoulC : Integer);

Begin
     X          := InitX;
     Y          := InitY;
     RayBoule   := InitRayB;
     CoulBoule  := InitCoulB;
     CoulCercle := InitCoulC;
     Visible    := False;
End;

{===========================================================================}
PROCEDURE Boule.Affiche;

Begin
     Visible := True;
     SetColor(CoulCercle);
     SetFillStyle(1,CoulBoule);
     Circle(X,Y,RayBoule);
     FloodFill(X,Y,GetColor);
End;

{===========================================================================}
PROCEDURE Boule.Cache;

Begin
     Visible := False;
     SetColor(GetBkColor);
     SetFillStyle(1,GetBkColor);
     Circle(X,Y,RayBoule);
     FloodFill(X,Y,GetBkColor);
End;

{===========================================================================}
FUNCTION Boule.EstVisible : Boolean;

Begin
     EstVisible := Visible;
End;

{===========================================================================}
PROCEDURE Boule.SetPosition (NouvoX,NouvoY : Integer);
Begin
     X := NouvoX;
     Y := NouvoY;
End;

{===========================================================================}
{**************************  Programme Principal ***************************}
VAR
   Boul, Boul2                                       : Boule;
   Grmode, GrPilote,CodeErreur                       : Integer;
   InitX, InitY, InitCoulB, InitCoulC, InitRayB      : Integer;
   NouvoX, NouvoY, X, Y                              : Integer;
   Rayon                                             : Integer;

BEGIN
     GrPilote := Detect;
     InitGraph(GrPilote,GrMode,'C:\TP7\BGI');
     CodeErreur := GraphResult;
     If CodeErreur <> 0 Then Begin
                                  Write('Erreur de type Graphique ');
                                  ReadLn;
                             End
     Else
     InitX     := 300;
     InitY     := 150;
     InitRayB  := 10;
     InitCoulB := 1;
     InitCoulC := 14;
     Rayon     := 130;
     Boul.Init(InitX, InitY, InitRayB, InitCoulB, InitCoulC);
     Boul.SetPosition(InitX,InitY+Rayon);
     Boul.Affiche;
     Boul2.Init(InitX+40, InitY+40, InitRayB, InitCoulB, InitCoulC-2);
     Boul2.SetPosition(InitX+40,InitY+40+Rayon);
     Boul2.Affiche;
     ReadLn;
     Boul.Cache;
     Boul2.Cache;

     For Y := -Rayon To Rayon Do
     Begin
          If (Y >= 0) And (Y < InitY) Then
             Begin
                  NouvoX := InitX + Round(Sqrt(Abs(Rayon*Rayon-Y*Y)));
                  NouvoY := InitY - Y;
             End;
          If (Y >= 0) And (Y > InitY) Then
             Begin
                  NouvoX := InitX + Round(Sqrt(Abs(Rayon*Rayon-Y*Y)));
                  NouvoY := InitY + Y;
             End;
          If (Y < 0) And (Abs(Y) < InitY) Then
             Begin
                  NouvoX := InitX - Round(Sqrt(Abs(Rayon*Rayon-Y*Y)));
                  NouvoY := InitY - Y;
             End;
          If (Y < 0) And (Abs(Y) > InitY) Then
             Begin
                  NouvoX := InitX - Round(Sqrt(Abs(Rayon*Rayon-Y*Y)));
                  NouvoY := InitY + Y;
             End;

          Boul.SetPosition(NouvoX,NouvoY);
          Boul.Affiche;
          Boul2.SetPosition(NouvoX+40,NouvoY+40);
          Boul2.Affiche;
          Delay(15);
          Boul.Cache;
          Boul2.Cache;
     End;
     ReadLn;
END.