UNIT  ObjBout;                            { 06/04/94
                                      Table des Mthodes Virtuelles }

INTERFACE
         USES
              Crt , Graph, Dos;
{============================ CLASSES ======================================}

TYPE
    Point = OBJECT
                  X, Y    : Integer;     { position du point }
                  CoulP   : Byte;        { couleur du point }
                  CoulF   : Byte;        { couleur du Fond }

                  CONSTRUCTOR Init (InitX, InitY : Integer);
                  PROCEDURE SetCouleur (Couleur, CoulFond : Byte);
                  PROCEDURE Affiche; Virtual;
                  PROCEDURE Cache;   Virtual;
                  PROCEDURE SetPosition (NouvoX, NouvoY : Integer);
                  PROCEDURE GetInfo (AncX, AncY : Integer; AncCoul,AncCoulF : Byte);
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    P_Bouton = OBJECT ( Point )
                    X1, Y1, X2, Y2  : Integer;
                    EpBord          : Integer;

                  CONSTRUCTOR Init (InitX1, InitY1, InitX2, InitY2 : Integer);
                  PROCEDURE Affiche; Virtual;
                  PROCEDURE Cache ;  Virtual;
                  PROCEDURE SetPosition (NouvoX, NouvoY, NouvoX2, NouvoY2, Ep_Bordure : Integer);
                  PROCEDURE SetTexte(Xt1,Yt1,Xt2,Yt2 : Integer; Texte : String; CoulT : Byte);
                  PROCEDURE GetInfo (AncX, AncY, AncX2, AncY2  : Integer; AncCoul : Byte);
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    P_BoutonS = OBJECT ( P_Bouton )
                       CoulB           : Byte;
                       


                  PROCEDURE SetCouleur (Couleur, CoulFond, CoulBord : Byte);
                  PROCEDURE Affiche; Virtual;
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    P_BoutonE = OBJECT (P_BoutonS)

                  PROCEDURE Affiche; Virtual;
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    G_Bouton = OBJECT ( P_Bouton )

                  PROCEDURE Affiche; Virtual;
                  PROCEDURE Cache; Virtual;
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    G_BoutonS = OBJECT ( G_Bouton )
                         CoulB           : Byte;

                  PROCEDURE SetCouleur (Couleur, CoulFond, CoulBord : Byte);
                  PROCEDURE Affiche; Virtual;
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
    G_BoutonE = OBJECT ( G_BoutonS )

                  PROCEDURE Affiche; Virtual;
            End;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
IMPLEMENTATION

{===========================================================================}
                        {*****  Objet Point *****}
{===========================================================================}
CONSTRUCTOR Point.Init (InitX, InitY : Integer);

Begin
     X := InitX;
     Y := InitY;

           If X < 1    Then  X := 1;
           If X > 600  Then  X := 600;
           If Y < 1    Then  Y := 1;
           If Y > 400  Then  Y := 400;
End;

{===========================================================================}
PROCEDURE Point.SetCouleur (Couleur, CoulFond : Byte);

Begin
     CoulP  := Couleur;
     CoulF  := CoulFond;
End;

{===========================================================================}
PROCEDURE Point.Affiche;

Begin
     SetBkColor(CoulF);
     SetColor(CoulP);
     PutPixel (X,Y,GetColor);
End;

{===========================================================================}
PROCEDURE Point.Cache;

Begin
     PutPixel (X,Y,GetBkColor);
End;

{===========================================================================}
PROCEDURE Point.SetPosition (NouvoX, NouvoY : Integer);

Begin
           X := NouvoX;
           Y := NouvoY;

           If X < 1    Then  X := 1;
           If X > 600  Then  X := 600;
           If Y < 1    Then  Y := 1;
           If Y > 400  Then  Y := 400;
End;

{===========================================================================}
PROCEDURE Point.GetInfo (AncX, AncY : Integer; AncCoul, AncCoulF : Byte);

Begin
     AncX     := X ;
     AncY     := Y;
     AncCoul  := CoulP;
     AncCoulF := CoulF;
End;

{===========================================================================}
                      {*****  Objet Petit_Bouton *****}
{**************************************************************************}
CONSTRUCTOR P_Bouton.Init (InitX1, InitY1, InitX2, InitY2 : Integer);

Begin
     X1 := InitX1;
     Y1 := InitY1;
     X2 := InitX2;
     Y2 := InitY2;
End;

{**************************************************************************}
PROCEDURE P_Bouton.Affiche;

Begin
      SetBkColor(CoulF);
      SetFillStyle(1,CoulP);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

End;

{***************************************************************************}
PROCEDURE P_Bouton.Cache;

Begin

      SetFillStyle(1,CoulF);      { couleur du bouton }
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(CoulF);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(CoulF);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

End;

{***************************************************************************}
PROCEDURE P_Bouton.SetPosition (NouvoX,NouvoY,NouvoX2,NouvoY2,Ep_Bordure : Integer);

Begin
           X1      :=  NouvoX;
           Y1      :=  NouvoY;
           X2      :=  NouvoX2;
           Y2      :=  NouvoY2;
           EpBord  :=  Ep_Bordure
End;

{***************************************************************************}
PROCEDURE P_Bouton.SetTexte(Xt1,Yt1,Xt2,Yt2 : Integer; Texte : String; CoulT : Byte);

Var  Long_Texte : Byte;

BEGIN
     SetColor(CoulT);
     Long_Texte := Length(Texte)*8 Div 2 ;
     OutTextXY((Xt1+Xt2) Div 2 - Long_Texte,
                                     (Yt2-Yt1) Div 2 + Yt1 - 3 , Texte);

END;

{===========================================================================}
PROCEDURE P_Bouton.GetInfo (AncX, AncY, AncX2, AncY2 : Integer; AncCoul : Byte);

Begin
     AncX     :=    X1 ;
     AncY     :=    Y1;
     AncX2    :=    X2 ;
     AncY2    :=    Y2;
     AncCoul  :=    CoulP;
End;

{===========================================================================}

{***************************************************************************}
                  {*****  Objet Petit_Bouton_Sortant *****}

{**************************************************************************}
PROCEDURE P_BoutonS.SetCouleur (Couleur, CoulFond, CoulBord : Byte);

Begin
     CoulP  := Couleur;
     CoulF  := CoulFond;
     CoulB  := CoulBord;
End;

{**************************************************************************}
PROCEDURE P_BoutonS.Affiche;

Var
   Xs1, Ys1, Xs2, Ys2   : Integer;

Begin
      Xs1 := X1 + EpBord ;   Ys1 := Y1 + EpBord;
      Xs2 := X2 - EpBord ;   Ys2 := Y2 - EpBord;

      SetBkColor(CoulF);
      SetFillStyle(1,CoulB);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

      SetFillStyle(1,CoulP);
      Bar(Xs1,Ys1,Xs2,Ys2);
      SetLineStyle(0,1,1);
      SetColor(8);
      Rectangle(Xs1,Ys1,Xs2,Ys2);
      SetColor(15);
      Line(Xs1,Ys1,Xs2,Ys1);
      Line(Xs1,Ys1,Xs1,Ys2-1);

End;

{***************************************************************************}
                 {*****  Objet Petit_Bouton_Entrant *****}
{**************************************************************************}
PROCEDURE P_BoutonE.Affiche;

Var
   Xs1, Ys1, Xs2, Ys2   : Integer;

Begin
      Xs1 := X1 + EpBord ;   Ys1 := Y1 + EpBord;
      Xs2 := X2 - EpBord ;   Ys2 := Y2 - EpBord;

      SetBkColor(CoulF);
      SetFillStyle(1,CoulB);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,1);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      Line(X1,Y1,X2,Y1);
      Line(X1,Y1,X1,Y2-1);

      SetFillStyle(1,CoulP);
      Bar(Xs1,Ys1,Xs2,Ys2);
      SetLineStyle(0,1,1);
      SetColor(15);
      Rectangle(Xs1,Ys1,Xs2,Ys2);
      SetColor(8);
      Line(Xs1,Ys1,Xs2,Ys1);
      Line(Xs1,Ys1,Xs1,Ys2-1);

End;

{***************************************************************************}
                 {*****  Objet Grand_Bouton *****}
{***************************************************************************}
PROCEDURE G_Bouton.Affiche;

Begin
      SetBkColor(CoulF);
      SetFillStyle(1,CoulP);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,3);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      SetLineStyle(0,1,1);
      Line(X1,Y1-1,X2,Y1-1);
      Line(X1,Y1,X2-1,Y1);
      Line(X1,Y1+1,X2-2,Y1+1);
      Line(X1-1,Y1,X1-1,Y2);
      Line(X1,Y1,X1,Y2-1);
      Line(X1+1,Y1,X1+1,Y2-2);

End;

{***************************************************************************}
PROCEDURE G_Bouton.Cache;

Begin
      SetBkColor(CoulF);
      SetFillStyle(1,CoulF);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,3);
      SetColor(CoulF);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(CoulF);
      SetLineStyle(0,1,1);
      Line(X1,Y1-1,X2,Y1-1);
      Line(X1,Y1,X2-1,Y1);
      Line(X1,Y1+1,X2-2,Y1+1);
      Line(X1-1,Y1,X1-1,Y2);
      Line(X1,Y1,X1,Y2-1);
      Line(X1+1,Y1,X1+1,Y2-2);
End;

{***************************************************************************}
                 {*****  Objet Grand_Bouton_Sortant *****}
{**************************************************************************}
PROCEDURE G_BoutonS.SetCouleur (Couleur, CoulFond, CoulBord : Byte);

Begin
     CoulP  := Couleur;
     CoulF  := CoulFond;
     CoulB  := CoulBord;
End;

{**************************************************************************}
PROCEDURE G_BoutonS.Affiche;

Var
   Xs1, Ys1, Xs2, Ys2   : Integer;

Begin
      Xs1 := X1 + EpBord ;   Ys1 := Y1 + EpBord;
      Xs2 := X2 - EpBord ;   Ys2 := Y2 - EpBord;

      SetBkColor(CoulF);
      SetFillStyle(1,CoulB);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,3);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      SetLineStyle(0,1,1);
      Line(X1,Y1-1,X2,Y1-1);
      Line(X1,Y1,X2-1,Y1);
      Line(X1,Y1+1,X2-2,Y1+1);
      Line(X1-1,Y1,X1-1,Y2);
      Line(X1,Y1,X1,Y2-1);
      Line(X1+1,Y1,X1+1,Y2-2);

      SetFillStyle(1,CoulP);
      Bar(Xs1,Ys1,Xs2,Ys2);
      SetLineStyle(0,1,3);
      SetColor(8);
      Rectangle(Xs1,Ys1,Xs2,Ys2);
      SetColor(15);
      SetLineStyle(0,1,1);
      Line(Xs1,Ys1-1,Xs2,Ys1-1);
      Line(Xs1,Ys1,Xs2-1,Ys1);
      Line(Xs1,Ys1+1,Xs2-2,Ys1+1);

      Line(Xs1-1,Ys1,Xs1-1,Ys2);
      Line(Xs1,Ys1,Xs1,Ys2-1);
      Line(Xs1+1,Ys1,Xs1+1,Ys2-2);

End;

{***************************************************************************}
                 {*****  Objet Grand_Bouton_Entrant *****}
{***************************************************************************}
PROCEDURE G_BoutonE.Affiche;

Var
   Xs1, Ys1, Xs2, Ys2   : Integer;

Begin
      Xs1 := X1 + EpBord ;   Ys1 := Y1 + EpBord;
      Xs2 := X2 - EpBord ;   Ys2 := Y2 - EpBord;

      SetBkColor(CoulF);
      SetFillStyle(1,CoulB);
      Bar(X1,Y1,X2,Y2);
      SetLineStyle(0,1,3);
      SetColor(8);
      Rectangle(X1,Y1,X2,Y2);
      SetColor(15);
      SetLineStyle(0,1,1);
      Line(X1,Y1-1,X2,Y1-1);
      Line(X1,Y1,X2-1,Y1);
      Line(X1,Y1+1,X2-2,Y1+1);
      Line(X1-1,Y1,X1-1,Y2);
      Line(X1,Y1,X1,Y2-1);
      Line(X1+1,Y1,X1+1,Y2-2);

      SetFillStyle(1,CoulP);
      Bar(Xs1,Ys1,Xs2,Ys2);
      SetLineStyle(0,1,3);
      SetColor(15);
      Rectangle(Xs1,Ys1,Xs2,Ys2);
      SetColor(8);
      SetLineStyle(0,1,1);
      Line(Xs1,Ys1-1,Xs2,Ys1-1);
      Line(Xs1,Ys1,Xs2-1,Ys1);
      Line(Xs1,Ys1+1,Xs2-2,Ys1+1);
      Line(Xs1-1,Ys1,Xs1-1,Ys2);
      Line(Xs1,Ys1,Xs1,Ys2-1);
      Line(Xs1+1,Ys1,Xs1+1,Ys2-2);

End;
{***************************************************************************}

END.

