PROGRAM POLAIRES;

USES    Crt, Printer;

CONST   TailleMax = 3600;

TYPE    Buffer = Array[0..TailleMax] Of Real;

VAR     Delta               : Real;
        Rho0                : Real;
        Teta                : ^Buffer;
        Rho                 : ^Buffer;
        x, y                : ^Buffer;
        i, n, k, h          : Integer;
        NbrEcrans           : Integer;
        NumEcrans           : Integer;
        Debut, Fin          : Integer;
        Touche              : Char;
        VarNbrEcr           : Real;
        Fichier, Lst        : Text;


{===========================================================================}
PROCEDURE CALCUL;

Begin
     ClrScr;
     For i:=0 To 1800 Do
                      Begin
                           Rho^[i]  := 0;
                           Teta^[i] := 0;       { Initialisation }
                           x^[i]    := 0;
                           y^[i]    :=0;
                      End;
     TextColor(3);
     GoToxy(7,3);
       Write('Donner la valeur de Rho0 (en mm) : ');
         ReadLn(Rho0);
     GoToxy(7,7);
       Write('Donner la valeur de l''incrment (en degr) : ');
         ReadLn(Delta);
     i:=1;
     n:=0;
     Repeat
           Teta^[i] := Teta^[i-1] + Delta;
           i := i + 1;
           n := n + 1;
     Until (Teta^[i-1] >= 180);
     VarNbrEcr := -125.634*Delta*Delta*Delta*Delta*Delta
                  +442.859*Delta*Delta*Delta*Delta
                  -599.045*Delta*Delta*Delta
                  +391.359*Delta*Delta
                  -127.815*Delta + 19.3039;
     NbrEcrans := Trunc(n/13);
     If Frac(n/13) > 1E-8 Then NbrEcrans := NbrEcrans + 1;
        If Delta <= 1 Then     NbrEcrans := NbrEcrans - Round(VarNbrEcr);
        If Delta = 13 Then     NbrEcrans := NbrEcrans - 1;
        If Delta = 0.4 Then    NbrEcrans := NbrEcrans + 1;

     Assign(Fichier, 'Resultat.dat');
     Rewrite(Fichier);
     WriteLn(Fichier,' Rho0 =',Rho0:5:3);
     WriteLn(Fichier,'----------------------------------------------------');
     WriteLn(Fichier,' Teta','       Rho','        x','           y');
     WriteLn(Fichier,'----------------------------------------------------');

     For i:=1 To n Do
              Begin
                   Teta^[i] := Teta^[i]*Pi/180;
                   Rho^[i]  := Rho0 * (Exp(Teta^[i])+Exp(-Teta^[i]))/2;
                   x^[i]    := Rho^[i] * Cos(Teta^[i]);
                   y^[i]    := Rho^[i] * Sin(Teta^[i]);
                   Teta^[i] := Teta^[i] * 180/Pi;

                   Write(Fichier,' ', Teta^[i]:3:1);
                   Write(Fichier,'        ', Rho^[i]:3:3);
                   Write(Fichier,'        ', x^[i]:3:3);
                   Write(Fichier,'        ', y^[i]:3:3);
                   WriteLn(Fichier);
              End;
     Close(Fichier);
End;

{===========================================================================}
PROCEDURE AFFICHAGE_TABLEAU;

Begin
     ClrScr;
     TextColor(15);
     For i:=1 To 57 Do
              Begin
                   GoToxy(7+i,3);   Write(Chr(205));
                   GoToxy(7+i,5);   Write(Chr(205));
                   GoToxy(7+i,20);  Write(Chr(205));
              End;
     For i:=1 To 16 Do
              Begin
                   GoToxy(7,3+i);   Write(Chr(186));
                   GoToxy(65,3+i);  Write(Chr(186));
                   GoToxy(17,3+i);  Write(Chr(186));
                   GoToxy(33,3+i);  Write(Chr(186));
                   GoToxy(50,3+i);  Write(Chr(186));
              End;
     GoToxy(7,3);    Write(Chr(201));
     GoToxy(7,5);    Write(Chr(204));
     GoToxy(7,20);   Write(Chr(200));
     GoToxy(65,3);   Write(Chr(187));
     GoToxy(65,5);   Write(Chr(185));
     GoToxy(65,20);  Write(Chr(188));
     GoToxy(17,5);   Write(Chr(206));
     GoToxy(33,5);   Write(Chr(206));
     GoToxy(50,5);   Write(Chr(206));
     GoToxy(17,3);   Write(Chr(203));
     GoToxy(33,3);   Write(Chr(203));
     GoToxy(50,3);   Write(Chr(203));
     GoToxy(17,20);  Write(Chr(202));
     GoToxy(33,20);  Write(Chr(202));
     GoToxy(50,20);  Write(Chr(202));

     TextColor(10);
     GoToxy(8,2);    Write('Rho0 =', Rho0:8:2);
     GoToxy(60,2);   Write(NumEcrans,'/',NbrEcrans);
     TextColor(3);
     GoToxy(10,4);    Write('Tta');
     GoToxy(24,4);   Write('Rho');
     GoToxy(42,4);   Write('X');
     GoToxy(58,4);   Write('Y');
End;

{===========================================================================}
                (*+++ Programme Principal +++*)
{===========================================================================}

BEGIN
     GetMem(Teta, SizeOf(Buffer));
     GetMem(Rho , SizeOf(Buffer));
     GetMem(x   , SizeOf(Buffer));
     GetMem(y   , SizeOf(Buffer));
     Calcul;
     k         := 0;
     Debut     := 1;
     Fin       := 14;
     NumEcrans := 1;
     Repeat
           Affichage_Tableau;
           h := 1;
           For i:=Debut To Fin Do
               Begin
                    GoToxy(9,5+h);   Write(Teta^[i]:3:1);
                    GoToxy(24,5+h);  Write(Rho^[i]:3:3);
                    GoToxy(40,5+h);  Write(x^[i]:3:3);
                    GoToxy(57,5+h);  Write(y^[i]:3:3);
                    h := h + 1;
               End;
     TextColor(15);
     GoToxy(7,22);   Write('Voulez-vous imprimer le tableau (O/N)? : ');
     Touche := ' ';
     While (UpCase(Touche)<>'O') And (UpCase(Touche)<>'N') Do
     Touche := ReadKey;
     If (UpCase(Touche)='O') Then
        Begin
             Assign(Lst, 'LPT1');
             Rewrite(Lst);
             WriteLn(Lst, '');
             WriteLn(Lst,'   Rho0 = ', Rho0:5:2);
             WriteLn(Lst, '-----------------------------------------');
             WriteLn(Lst,'   Teta','   Rho','    X','    Y');
             WriteLn(Lst, '-----------------------------------------');
             For i:=Debut To Fin Do
                          Begin
                               Write(Lst,' ', Teta^[i]:3:1);
                               Write(Lst,'        ', Rho^[i]:3:3);
                               Write(Lst,'        ', x^[i]:3:3);
                               Write(Lst,'        ', y^[i]:3:3);
                               WriteLn(Lst,' ');
                          End;
             Close(Lst);
        End;
        k         := k + 1;
        Debut     := Fin + 1;
        Fin       := Debut + 13;
        NumEcrans := NumEcrans + 1;

     Until (k=NbrEcrans);
     ClrScr;
     Writeln; WriteLn; WriteLn;
     WriteLn('                             Appuyer sur ENTREE ...');
     ReadLn;
     FreeMem(Teta, SizeOf(Buffer));
     FreeMem(Rho , SizeOf(Buffer));
     FreeMem(x   , SizeOf(Buffer));
     FreeMem(y   , SizeOf(Buffer));
     ClrScr;
END.