PROGRAM ResIn;                              { au 09/04/98 par: Lad MESSAOUDI}
{$R+} {$S+}


USES    Graph, Imane, Mouse, Cursors, Crt, Imane2D;

CONST   Cf = 9;                                { Couleur de fond }
        NbBout = 10;                           { Nombre de boutons d'lments }
        NbZonGrp = 2;                          { Nombre de zones de groupes }
        NbBoutMen = 9;                         { Nombre de boutons du Menu }
        NbZonH = 56;                           { Nombre de zones de dessin horizontales }
        NbZonV = 56;                           { Nombre de zones de dessin verticales }

VAR     GraphPilot, GraphMode      : Integer;
        MaxX, MaxY, NbreCouleurs   : Integer;
        FenPr                      : Bouton;
        ZoneMessages               : Bouton;
        BoutRac                    : Array[0..NbBout] Of Bouton;
        ZonGrp                     : Array[0..NbZonGrp] Of Bouton;
        BoutMenu                   : Array[0..NbBoutMen] Of Bouton;
        Fen                        : Array[0..4] Of Bouton;
        ZoneH                      : Array[0..NbZonH] Of Bouton;
        ZoneV                      : Array[0..NbZonV] Of Bouton;
        X1f, X2f, Y1f, Y2f         : Integer;
        i, j, k, BtnCount          : Integer;
        GMouse                     : GraphicMouse;
        mButton                    : Position;
        Status, Exit               : Boolean;
        XPos, YPos, BtnStatus      : Integer;
        Bt                         : Array[0..NbBout] Of Boolean;
        Dxg, Dyg, Dxz, Dyz         : Integer;

{===========================================================================}
PROCEDURE INITIALISATION_CARTE_GRAPHIQUE (Chemin : String);

Var    ErrorCode : Integer;

BEGIN
       GraphPilot:=Detect;
       InitGraph(GraphPilot,GraphMode,Chemin);
       ErrorCode := GraphResult;
       if ErrorCode <> GrOk Then
          Begin
               WriteLn ('Erreur graphique : ',GraphErrorMsg(ErrorCode));
               Halt (1)
          End;
   MaxX := GetMaxX;
   MaxY := GetMaxY;
   NbreCouleurs := GetMaxColor;
END;
{===========================================================================}
PROCEDURE INITIALISATION_OBJETS;

BEGIN
     FenPr.Init(0,0,0,0);
     ZoneMessages.Init(0,0,0,0);

     For i:=1 To NbBout Do
              Begin
                   BoutRac[i].Init(0,0,0,0);
              End;
     For i:=1 To NbZonGrp Do
              Begin
                   ZonGrp[i].Init(0,0,0,0);
              End;
     For i:=1 To NbBoutMen Do
              Begin
                   BoutMenu[i].Init(0,0,0,0);
              End;
     For k:=1 To 4 Do
              Begin
                   Fen[k].Init(0,0,0,0);
              End;
     For i:=1 To NbZonH Do
              Begin
                   ZoneH[i].Init(0,0,0,0);
              End;
     For i:=1 To NbZonV Do
              Begin
                   ZoneV[i].Init(0,0,0,0);
              End;
END;
{===========================================================================}
PROCEDURE Position_Souris;

Begin
     GMouse.GetPosition(BtnStatus,XPos, YPos);
End;
{===========================================================================}
PROCEDURE Ecrit_BtnRac;

Begin
      BoutRac[1].SetTexte(550,62,580,87,'Tu',14);
      BoutRac[2].SetTexte(550,92,580,117,'Co',14);
      BoutRac[3].SetTexte(550,122,580,147,'Va',14);
      BoutRac[4].SetTexte(550,152,580,177,'Er',14);
      BoutRac[5].SetTexte(550,182,580,207,'Sr',14);
      BoutRac[6].SetTexte(595,62,625,87,'Eb',14);
      BoutRac[7].SetTexte(595,92,625,117,'Eg',14);
      BoutRac[8].SetTexte(595,122,625,147,'Rb',14);
      BoutRac[9].SetTexte(595,152,625,177,'Rg',14);
      BoutRac[10].SetTexte(595,182,625,207,'Po',14);
End;

{===========================================================================}
PROCEDURE Ecrit_BtnMen;

Begin
      BoutMenu[1].SetTexte(550,260,625,280,'Nouveau',15);
      BoutMenu[2].SetTexte(550,283,625,303,'Ouvrir',15);
      BoutMenu[3].SetTexte(550,306,625,326,'Calcul',15);
      BoutMenu[4].SetTexte(550,329,625,349,'Enreg.',15);
      BoutMenu[5].SetTexte(550,352,625,372,'Enr/Sous',15);
      BoutMenu[6].SetTexte(550,375,625,395,'Fermer',15);
      BoutMenu[7].SetTexte(550,398,625,418,'Quitter',15);
      BoutMenu[8].SetTexte(550,421,625,441,'Aide',15);
      BoutMenu[9].SetTexte(550,444,625,464,'A propos',15);
End;
{===========================================================================}
PROCEDURE Detect_Zone_Dessin;

BEGIN
     Dxz := Trunc(Dxg/10);
     Dyz := Trunc(Dyg/10);
     k:=1;
     SetColor(7);
     For i:=0 To 7 Do
       For j := 1 To 7 Do
         Begin
              ZoneH[k].SetType(PBouton);
              ZoneH[k].SetPosition(X1f+i*Dxg, Y1f+j*Dyg-Dyz,X1f+(i+1)*Dxg,Y1f+j*Dyg+Dyz,1);
              ZoneH[k].Affiche;
              k:=k+1;
         End;
     k:=1;
     For i:=1 To 7 Do
       For j := 0 To 7 Do
         Begin
              ZoneV[k].SetType(PBouton);
              ZoneV[k].SetPosition(X1f+i*Dxg-Dxz, Y1f+j*Dyg+Dyz,X1f+i*Dxg+Dxz,Y1f+(j+1)*Dyg-Dyz,1);
              ZoneV[k].Affiche;
              k:=k+1;
         End;
END;
{===========================================================================}
PROCEDURE FOND_MENU;

BEGIN
     X1f := 2;    Y1f := 20;   X2f := 544;  Y2f := 442;

     ClearDevice;
     SetColor(13);
     Rectangle(0,0,MaxX,MaxY);
     SetFillStyle(1,3);
     Bar(1,1,MaxX-1,MaxY-1);

     With ZoneMessages Do
          Begin
               SetType(PBouton);
               SetCouleur(7,Cf,7);
               SetPosition(2,444,MaxX-100,MaxY-2,2);
               Etat:= False;
               Affiche;
          End;

     With FenPr Do
          Begin
               SetType(NBouton);
               SetPosition(X1f,Y1f,X2f-5,Y2f,0);
               Affiche;
          End;

     With ZonGrp[1] Do
          Begin
               SetType(PBouton);
               SetCouleur(7,Cf,7);
               SetPosition(542,20,636,215,2);
               Etat := False;
               Affiche;
          End;

     With ZonGrp[2] Do
          Begin
               SetType(PBouton);
               SetCouleur(7,Cf,7);
               SetPosition(542,220,636,MaxY-2,2);
               Etat := False;
               Affiche;
          End;

    k := 0;
    For i:=1 To 5 Do
        Begin
             BoutRac[i].SetPosition(550,62+k,580,87+k,0);
             k := k + 30;
        End;
    k := 0;
    For i:=6 To 10 Do
        Begin
             BoutRac[i].SetPosition(595,62+k,625,87+k,0);
             k := k + 30;
        End;

    For i:=1 To NbBout Do
        Begin
             With BoutRac[i] Do
                Begin
                     SetType(PBouton);
                     SetCouleur(7,Cf,7);
                     Etat := True;
                     Affiche;
                End;
        End;
    k := 0;
    For i:=1 To NbBoutMen Do
        Begin
             BoutMenu[i].SetPosition(550,260+k,625,280+k,0);
             k := k + 23;
             With BoutMenu[i] Do
                Begin
                     SetType(PBouton);
                     SetCouleur(7,Cf,12);
                     Etat := True;
                     Affiche;
                End
        End;
END;
{===========================================================================}
PROCEDURE MESSAGE (Mess : String);

BEGIN
     SetColor(1);
     OutTextXY(10,458,Mess);
END;
{===========================================================================}
PROCEDURE Grille;

BEGIN
     SetLineStyle(1,1,1);
     SetColor(10);
     Dxg := Trunc((X2f - X1f)/8);
     Dyg := Trunc((Y2f - Y1f)/8);
     For i:=1 To 7 Do
         Begin
              Line(X1f+i*Dxg, Y1f-10, X1f+i*Dxg, Y2f);
              Line(X1f-2, Y1f+i*Dyg, X2f, Y1f+i*Dyg);
         End;
     SetLineStyle(0,0,0);
END;
{===========================================================================}
PROCEDURE MENU_PRINCIPAL;

BEGIN
     Fond_Menu;
     Grille;
     Detect_Zone_Dessin;

     SetColor(1);
         OutTextXY(560,30,'ELEMENTS');
         Line(545,45,630,45);
     OutTextXY(560,230,'FICHIERS');
     Line(545,245,630,245);
     Ecrit_BtnRac;
     Ecrit_BtnMen;
END;
{===========================================================================}
PROCEDURE A_PROPOS;

BEGIN
     With Fen[1] Do
          Begin
               SetType(PBouton);
               SetCouleur(7,3,13);
               Etat := True;
               SetPosition(70,50,550,430,5);
               Affiche;
          End;
     With Fen[2] Do
          Begin
               SetType(PBouton);
               SetCouleur(7,3,13);
               Etat := False;
               SetPosition(70,50,550,430,5);
               Affiche;
          End;
     With Fen[3] Do
          Begin
               SetType(PBouton);
               SetCouleur(1,3,1);
               Etat := False;
               SetPosition(90,65,530,100,0);
               Affiche;
               SetTextStyle(4,0,2);
               SetColor(14);
               OutTextXY(250,67,'A Propos de...');
               SetTextStyle(0,0,0);
          End;
      With Fen[4] Do
          Begin
               SetType(PBouton);
               SetCouleur(7,3,1);
               Etat := False;
               SetPosition(110,130,510,400,0);
               Affiche;
               SetColor(1);
               OutTextXY(255,150,'ResIn V 1.0');
               OutTextXY(125,180,'Logiciel de calcul des rseaux en fluide');
               OutTextXY(125,200,'incompressible intgrant les modules:');
               OutTextXY(145,220,'- Cration d''un nouveau rseau,');
               OutTextXY(145,240,'- Modification d''un rseau existant,');
               OutTextXY(145,260,'- Bibliothque des pertes de charge,');
               OutTextXY(145,280,'- Sauvegarde et impression des rseaux.');
               SetColor(14);
               OutTextXY(125,340,'Ce logiciel est ralis avec TurboPascal V 5.5.');

               SetColor(15);
               OutTextXY(170,370,'Copyrite 1998 by : Lad MESSAOUDI.');
          End;
END;

{===========================================================================}
PROCEDURE Dessin;

BEGIN
     SetColor(15);
     For i:=1 To NbBout Do
         If Bt[i]=True Then
            Case i Of
            1 : Begin
                     Detect_Zone_Dessin;
                     Line(XPos,YPos,XPos+65,YPos);
                     Line(XPos,YPos+20,XPos+65,YPos+20);
                End;
            2 : Begin
                     Detect_Zone_Dessin;
                     Line(XPos,YPos,XPos+65,YPos);Line(XPos+65,YPos,XPos+65,YPos+53);
                     Line(XPos,YPos+20,XPos+45,YPos+20);Line(XPos+45,YPos+20,XPos+45,YPos+53);
                End;
            3 : Begin
                     Detect_Zone_Dessin;
                     Line(XPos,YPos,XPos+65,YPos);Line(XPos+65,YPos,XPos+65,YPos+53);
                     Line(XPos,YPos,XPos,YPos+53);Line(XPos,YPos+53,XPos+65,YPos+53);
                     Line(XPos,YPos,XPos+65,YPos+53);Line(XPos,YPos+53,XPos+65,YPos);
                End;

            End;
END;
{===========================================================================}
PROCEDURE CHOIX;

BEGIN

GMouse.Reset (Status, BtnCount);
 Exit := False;
  If Status Then
  Begin
       GMouse.Initialize;
       GMouse.SetCursor (LaidCur2);
       GMouse.Show (True);
       Position_Souris;
       Repeat
             GMouse.QueryBtnDn (ButtonL, mButton);
             Grille;
             If mButton.OpCount > 0 Then
             Begin
                  GMouse.Show (False);
                  Position_Souris;
                  If FenPr.BoutonHit (mButton.XPos, mButton.YPos) Then
                                          Begin
                                               Dessin;
                                          End;
                 {================ Gestion Boutons Elments ================}

                  For i:= 1 To NbBout Do
                  Begin
                  If BoutRac[i].BoutonHit (mButton.XPos, mButton.YPos) Then
                  Begin
                       GMouse.Show (True);
                       If i=1 Then
                          Begin
                               If BoutRac[1].Etat Then
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (LaidCur2);
                                       GMouse.Show (True);
                                       ZoneMessages.Affiche;
                                       Bt[1] := False;
                                  End
                                  Else
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (TuCur);
                                       GMouse.Show (True);
                                       Message('Ajout d''une conduite (ou tuyau).');
                                       Bt[1] := True;
                                  End;
                               Ecrit_BtnRac;
                          End;

                       If i=2 Then
                          Begin
                               If BoutRac[2].Etat Then
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (LaidCur2);
                                       GMouse.Show (True);
                                       ZoneMessages.Affiche;
                                       Bt[2] := False;
                                  End
                                  Else
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (CoCur);
                                       GMouse.Show (True);
                                       Message('Ajout d''un coude de 90.');
                                       Bt[2] := True;
                                  End;
                               Ecrit_BtnRac;
                          End;
                       If i=3 Then
                          Begin
                               If BoutRac[3].Etat Then
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (LaidCur2);
                                       GMouse.Show (True);
                                       ZoneMessages.Affiche;
                                       Bt[3] := False;
                                  End
                                  Else
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (VaCur);
                                       GMouse.Show (True);
                                       Message('Ajout d''une vane.');
                                       Bt[3] := True;
                                  End;
                               Ecrit_BtnRac;
                          End;
                       If i=4 Then
                          Begin
                               If BoutRac[4].Etat Then
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (LaidCur2);
                                       GMouse.Show (True);
                                       ZoneMessages.Affiche;
                                       Bt[4] := False;
                                  End
                                  Else
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (ErCur);
                                       GMouse.Show (True);
                                       Message('Ajout d''une Entre de rservoir.');
                                       Bt[4] := True;
                                  End;
                               Ecrit_BtnRac;
                          End;
                       If i=5 Then
                          Begin
                               If BoutRac[5].Etat Then
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (LaidCur2);
                                       GMouse.Show (True);
                                       ZoneMessages.Affiche;
                                       Bt[5] := False;
                                  End
                                  Else
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (SrCur);
                                       GMouse.Show (True);
                                       Message('Ajout d''une sortie de rservoir.');
                                       Bt[5] := True;
                                  End;
                               Ecrit_BtnRac;
                          End;
                       If i=6 Then
                          Begin
                               If BoutRac[6].Etat Then
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (LaidCur2);
                                       GMouse.Show (True);
                                       ZoneMessages.Affiche;
                                       Bt[6] := False;
                                  End
                                  Else
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (EbCur);
                                       GMouse.Show (True);
                                       Message('Ajout d''un largissement brusque.');
                                       Bt[6] := True;
                                  End;
                               Ecrit_BtnRac;
                          End;
                       If i=7 Then
                          Begin
                               If BoutRac[7].Etat Then
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (LaidCur2);
                                       GMouse.Show (True);
                                       ZoneMessages.Affiche;
                                       Bt[7] := False;
                                  End
                                  Else
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (EgCur);
                                       GMouse.Show (True);
                                       Message('Ajout d''un largissement graduel.');
                                       Bt[7] := True;
                                  End;
                               Ecrit_BtnRac;
                          End;
                       If i=8 Then
                          Begin
                               If BoutRac[8].Etat Then
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (LaidCur2);
                                       GMouse.Show (True);
                                       ZoneMessages.Affiche;
                                       Bt[8] := False;
                                  End
                                  Else
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (RbCur);
                                       GMouse.Show (True);
                                       Message('Ajout d''un retraississement brusque.');
                                       Bt[8] := True;
                                  End;
                               Ecrit_BtnRac;
                          End;
                       If i=9 Then
                              Begin
                                   If BoutRac[9].Etat Then
                                   Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (LaidCur2);
                                       GMouse.Show (True);
                                       ZoneMessages.Affiche;
                                       Bt[9] := False;
                                  End
                                  Else
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (RgCur);
                                       GMouse.Show (True);
                                       Message('Ajout d''un retraississement graduel.');
                                       Bt[9] := True;
                                  End;
                               Ecrit_BtnRac;
                              End;
                       If i=10 Then
                          Begin
                               If BoutRac[10].Etat Then
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (LaidCur2);
                                       GMouse.Show (True);
                                       ZoneMessages.Affiche;
                                       Bt[10] := False;
                                  End
                                  Else
                                  Begin
                                       GMouse.Show (False);
                                       GMouse.SetCursor (PoCur);
                                       GMouse.Show (True);
                                       Message('Ajout d''une pompe.');
                                       Bt[10] := True;
                                  End;
                               Ecrit_BtnRac;
                          End;
                  End;
                  End;
                  {================ Gestion Boutons Menu ===================}

                  For i:= 1 To NbBoutMen Do
                  Begin
                  If BoutMenu[i].BoutonHit (mButton.XPos, mButton.YPos) Then
                  Begin
                       GMouse.Show (True);
                       If i=1 Then
                          Begin
                               Ecrit_BtnMen;
                          End;
                       If i=2 Then
                          Begin
                               Ecrit_BtnMen;
                          End;
                       If i=3 Then
                          Begin
                               Ecrit_BtnMen;
                          End;
                       If i=4 Then
                          Begin
                               Ecrit_BtnMen;
                          End;
                       If i=5 Then
                          Begin
                               Ecrit_BtnMen;
                          End;
                       If i=6 Then
                          Begin
                               Ecrit_BtnMen;
                          End;
                       If i=7 Then
                          Begin
                               Delay(100);
                               Exit := True;
                          End;
                       If i=8 Then
                          Begin
                               Ecrit_BtnMen;
                          End;
                       If i=9 Then
                          If BoutMenu[9].Etat Then
                               Begin
                                    GMouse.Show (False);
                                    Menu_Principal;
                                    Choix;
                                    GMouse.Show (True);
                               End
                               Else
                               Begin
                                    GMouse.Show (False);
                                    Ecrit_BtnMen;
                                    A_Propos;
                                    GMouse.SetLimits(550,444,625,464);
                                    GMouse.Show (True);
                               End;
                  End;
                  End;
                  GMouse.Show (True);
             End;
       Until Exit;
  End;
END;

{===========================================================================}
{***************************************************************************}
{========================= Programme principal =============================}
{***************************************************************************}

BEGIN
     INITIALISATION_CARTE_GRAPHIQUE ('D:\BP\BGI');
     INITIALISATION_OBJETS;
     MENU_PRINCIPAL;
     CHOIX;
     CloseGraph;
END.